Index: libabac/abac_verifier.c
===================================================================
--- libabac/abac_verifier.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_verifier.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -7,52 +7,30 @@
 
 #include <stdio.h>
-#include <regex.h>
-#include <sys/mman.h>
-#include <fcntl.h>
 #include <sys/types.h>
-#include <sys/stat.h>
-#include <unistd.h>
-
-
 #include <assert.h>
-#include <stdio.h>
 
 #include <library.h>
 
+#include <chunk.h>
 #include "abac_internal.h"
-#include "abac_verifier.h"
-
 #include "abac_util.h"
-#include "abac_rt.h"
+#include "abac_context.h"
+#include "abac_list.h"
+#include "abac_stack.h"
+#include "uthash.h"
+#include "abac_id.h"
+#include "abac_attribute.h"
+#include "abac_pl_yap.h"
 
 static int debug=0;
-
-/* from abac_attribute.c */
-extern char *get_cred_encoding(abac_attribute_t *ptr);
-
-extern abac_aspect_t *abac_yy_get_rule_head_aspect();
-extern abac_aspect_t *abac_yy_get_rule_tail_aspect();
-extern abac_list_t *abac_yy_get_rule_clauses();
-extern char* abac_decode_string(char *);
-extern void abac_yy_free_rule_clauses();
-extern char *generate_pl_type_clause(char *, int);
-extern abac_list_t *generate_pl_clauses(abac_aspect_t *, abac_aspect_t *);
-extern void generate_pl_set_abac_yyfptr_encoded(char *string);
-
-extern void abac_print_aspect_string_with_condition(abac_aspect_t *role, FILE*);
-
-extern int abac_id_load_privkey_chunk(abac_id_t *ptr, chunk_t keychunk);
-
+static int hack=1;
+
+/* need to add locks onto theseXXX */
+/* hash table base on sha with a p */
 struct _abac_id_credential_t {
-    char *hashkeyid; 
+    char *hashkeyid;
     abac_id_t *id;
-    char *pl_clause;
-
     UT_hash_handle hh;
 };
-/* hash table base on sha with a p */
-abac_id_credential_t *id_creds = NULL;
-/* linked list of all the ids's hashkeyid */
-abac_list_t *id_hashkeyid_list = NULL;
 
 /* can store either role or oset */
@@ -60,14 +38,271 @@
     char *hashkeyid;
     abac_attribute_t *attr;
-    abac_list_t *pl_clauses;
-
     UT_hash_handle hh;
 };
+
+typedef struct _abac_verifier_session_t {
+    abac_list_t *contexts;
+    char *stub; /* namespace stub */
+
+    abac_id_credential_t *id_creds;
+/* linked list of all the ids's hashkeyid */
+    abac_list_t *id_hashkeyid_list;
+
 /* hash table base on encoded attr rule */
-abac_credential_t *attr_creds = NULL;
-/* linked list of all the attr's hashkeyid */
-abac_list_t *attr_hashkeyid_list = NULL;
-
-/*****************************************************************************/
+/* can store either role or oset */
+    abac_credential_t *attr_creds;
+    abac_list_t *attr_hashkeyid_list;
+
+} abac_verifier_session_t;
+
+
+/* **GLOBAL** the one and only */
+abac_verifier_session_t *abac_session=NULL;
+
+/* local */
+abac_id_t *abac_id_credential_id(abac_id_credential_t *ptr);
+char *abac_idtype_string(int i);
+/****************************************************************/
+void show_debug_info(const char *msg)
+{
+    int ctxt_sz=0;
+    int id_sz=0;
+    int attr_sz=0;
+    if(abac_session !=NULL) {
+        ctxt_sz=abac_list_size(abac_session->contexts);
+        id_sz=abac_list_size(abac_session->id_hashkeyid_list);
+        attr_sz=abac_list_size(abac_session->attr_hashkeyid_list);
+    }
+    fprintf(stderr,"/* ===== %s ======== */\n",msg);
+    fprintf(stderr,"  number of contexts: %d\n",ctxt_sz);
+    fprintf(stderr,"  number of principals: %d\n",id_sz);
+    fprintf(stderr,"  number of attributes: %d\n",attr_sz);
+    
+}
+
+static void _check_id_cred(abac_id_credential_t *id_cred)
+{
+    if(id_cred) {
+        printf("checking on this id_cred location %d\n", (int)id_cred);
+        printf("  --> sha is (%s)\n", abac_id_keyid(id_cred->id));
+        printf("  --> cn is (%s)\n", abac_id_cn(id_cred->id));
+    }
+}
+
+/* retrieve the cn that is associated with this sha_string, checking
+   with just the master list */
+char *abac_cn_with_sha(char *sha_string)
+{
+   // get the issuer based on keyid
+    abac_id_credential_t *id_cred;
+    HASH_FIND_STR(abac_session->id_creds, sha_string, id_cred);
+    if (id_cred == NULL) {
+        return NULL;
+    }
+    if(debug)
+        _check_id_cred(id_cred);
+    return abac_id_cn(id_cred->id);
+}
+
+char *abac_idtype_with_sha(char* sha_string)
+{
+    // get the issuer based on keyid
+    abac_id_credential_t *id_cred;
+    HASH_FIND_STR(abac_session->id_creds, sha_string, id_cred);
+    if (id_cred == NULL) {
+        // this id, sha string is not in the db...
+        DEBUG_PRINTF("abac_idtype_with_sha: this id is not in the id_creds list\n");
+        return NULL;
+    }
+    int idtype=abac_id_idtype(id_cred->id);
+    return abac_idtype_string(idtype);
+}
+
+/****************************************************************/
+/**
+ * abac_credential_t                                
+**/
+abac_id_credential_t *abac_id_credential_new(abac_id_t *a_id)
+{
+    char *keyid=abac_id_keyid(a_id);
+
+    abac_id_credential_t *id_cred = abac_xmalloc(sizeof(abac_id_credential_t));
+    id_cred->hashkeyid = abac_xstrdup(keyid);
+    id_cred->id=abac_id_dup(a_id);
+    return id_cred;
+}
+
+abac_id_credential_t *abac_id_credential_dup(abac_id_credential_t *ptr)
+{
+    assert(ptr != NULL);
+    DEBUG_PRINTF("calling abac_id_credential_dup, increment id ref count\n");
+    abac_id_dup(ptr->id);
+    return ptr;
+}
+
+abac_id_t *abac_id_credential_id(abac_id_credential_t *ptr)
+{
+    assert(ptr);
+    return ptr->id;
+}
+
+char *abac_id_credential_hashkey(abac_id_credential_t *ptr)
+{
+    assert(ptr);
+    return ptr->hashkeyid;
+}
+
+/* XXX needs to lock this !! */
+void abac_add_id_cred(abac_id_credential_t *id_cred)
+{
+    HASH_ADD_KEYPTR(hh, abac_session->id_creds, id_cred->hashkeyid,
+                                     strlen(id_cred->hashkeyid), id_cred);
+    abac_list_add(abac_session->id_hashkeyid_list,
+                                        abac_xstrdup(id_cred->hashkeyid));
+
+    DEBUG_PRINTF("-->adding into master id_creds, key(%s)..idx(%d)sz(%d)\n",
+       id_cred->hashkeyid, HASH_COUNT(abac_session->id_creds),
+       abac_list_size(abac_session->id_hashkeyid_list));
+}
+
+abac_id_credential_t *abac_check_id_cred(char *keyid)
+{
+    abac_id_credential_t *id_cred=NULL;
+    HASH_FIND_STR(abac_session->id_creds, keyid, id_cred);
+    return id_cred;
+}
+
+void abac_id_credential_free(abac_id_credential_t *ptr)
+{
+    char *keyid=ptr->hashkeyid;
+    int found=0;
+
+    DEBUG_PRINTF("abac_id_credential_free: keyid(%s)\n", keyid);
+
+    char *cur=NULL;
+    abac_list_foreach(abac_session->id_hashkeyid_list, cur,
+        if(strcmp(cur,keyid)==0) {
+            found=1;
+            break;
+        }
+    );
+    assert(found==1); // big panic
+
+    // this is very tricky...
+    int last=abac_id_lastone(ptr->id);
+    if(!last) {
+        abac_id_free(ptr->id);
+        } else {
+            DEBUG_PRINTF("abac_id_credential_free: deleting id (%s)(%s)\n",abac_id_name(ptr->id), cur);
+            abac_list_remove(abac_session->id_hashkeyid_list, cur);
+            free(cur);
+
+            free(ptr->hashkeyid);
+            abac_id_free(ptr->id);
+            HASH_DEL(abac_session->id_creds, ptr);
+            free(ptr);
+    }
+}
+
+/****************************************************************/
+/**
+ * abac_credential_t                                
+**/
+
+abac_credential_t *abac_credential_new(abac_attribute_t *attr, char* key)
+{
+    abac_credential_t *cred = abac_xmalloc(sizeof(abac_credential_t));
+    cred->hashkeyid=abac_xstrdup(key);
+    cred->attr=abac_attribute_dup(attr);
+    return cred;
+}
+
+abac_attribute_t *abac_credential_attribute(abac_credential_t *ptr)
+{
+    assert(ptr!=NULL);
+    return ptr->attr;
+}
+
+abac_credential_t *abac_credential_dup(abac_credential_t *ptr)
+{
+    assert(ptr != NULL);
+    abac_attribute_dup(ptr->attr);
+    return ptr;
+}
+
+void abac_add_cred(abac_credential_t *cred)
+{
+    HASH_ADD_KEYPTR(hh, abac_session->attr_creds, cred->hashkeyid,
+                                         strlen(cred->hashkeyid), cred);
+    abac_list_add(abac_session->attr_hashkeyid_list,
+                                     abac_xstrdup(cred->hashkeyid));
+
+    DEBUG_PRINTF("-->adding into master attr_creds, key(%s)..idx(%d)sz(%d)\n",
+          abac_decode_string(cred->hashkeyid), HASH_COUNT(abac_session->attr_creds),
+          abac_list_size(abac_session->attr_hashkeyid_list));
+}
+
+
+abac_aspect_t *abac_credential_head(abac_credential_t *cred)
+{
+    return abac_attribute_head(cred->attr);
+}
+
+abac_aspect_t *abac_credential_tail(abac_credential_t *cred) 
+{
+    return abac_attribute_tail(cred->attr);
+}
+
+char *abac_credential_hashkey(abac_credential_t *ptr)
+{
+    assert(ptr);
+    return ptr->hashkeyid;
+}
+
+abac_credential_t *abac_check_cred(char *keyid)
+{
+    abac_credential_t *cred=NULL;
+    HASH_FIND_STR(abac_session->attr_creds, keyid, cred);
+    return cred;
+}
+
+/**
+ * Decrease the reference count of a credential, freeing it when it reaches 0.
+ */
+void abac_credential_free(abac_credential_t *ptr)
+{
+    /* first make sure it is there */
+    char *keyid=ptr->hashkeyid;
+    int found=0;
+
+    DEBUG_PRINTF("abac_credential_free: keyid(%s)\n", keyid);
+
+    char *cur;
+    abac_list_foreach(abac_session->attr_hashkeyid_list, cur,
+        if(strcmp(cur,keyid)==0) {
+            found=1;
+            break;
+        }
+    );
+    assert(found==1); // big panic
+
+    // this is very tricky...
+    int last=abac_attribute_lastone(ptr->attr);
+    if(!last) {
+        abac_attribute_free(ptr->attr);
+        } else {
+
+            abac_list_remove(abac_session->attr_hashkeyid_list, cur);
+            free(cur);
+
+            DEBUG_PRINTF("abac_credential_free: real free for (%d)\n",(int) ptr);
+            free(ptr->hashkeyid);
+            abac_attribute_free(ptr->attr);
+            HASH_DEL(abac_session->attr_creds, ptr);
+            free(ptr);
+    }
+}
+
+/****************************************************************/
 void abac_print_cred_info(abac_credential_t *cred, FILE *fp)
 {
@@ -79,29 +314,9 @@
     abac_aspect_t *tail=abac_attribute_tail(ptr);
 
-    if(debug) {
-        fprintf(fp,"---> printing out credential info cred(%d)..\n", (int) cred);
-        if(head) {
-            abac_print_aspect_string_with_condition(head,fp);
-        }
-        if(tail) {
-            abac_print_aspect_string_with_condition(tail,fp);
-        }
-
-        abac_list_t *clauses=cred->pl_clauses;
-        if (clauses != NULL) {
-            char *cur=NULL;
-            abac_list_foreach(clauses, cur,
-                fprintf(fp,"\n  a clause(%d):\n",(int)cur);
-                if(cur)
-                    fprintf(fp,"strlen(%d)loc(%d)(%s)\n", strlen(cur),(int)cur, cur);
-            );
-        }
-        } else {
-            fprintf(fp," ");
-            abac_print_aspect_string_with_condition(head,fp);
-            fprintf(fp," <- ");
-            abac_print_aspect_string_with_condition(tail,fp);
-            fprintf(fp,"\n");
-   }
+    fprintf(fp," ");
+    abac_print_aspect_string_with_condition(head,fp);
+    fprintf(fp," <- ");
+    abac_print_aspect_string_with_condition(tail,fp);
+    fprintf(fp,"\n");
 }
 
@@ -109,300 +324,72 @@
 {
     if(fp == NULL)
-        return;
+        fp=stdout;
 
     abac_id_t *ptr=abac_id_credential_id(prin);
-
-    if(debug) fprintf(fp,"---> printing out principal info ..\n");
     if(abac_id_has_privkey(ptr))
-        fprintf(fp," (%s,%s,y)\n",abac_id_name(ptr),abac_id_idtype_string(ptr));
+        fprintf(fp," [%s,%s] #y\n",abac_id_idtype_string(ptr), abac_id_name(ptr));
         else
-            fprintf(fp," (%s,%s,n)\n",abac_id_name(ptr),abac_id_idtype_string(ptr));
-}
-
-// 
-int abac_verify_idtype_type(char *type) {
-    int i;
-
-    if (type == NULL)
-        return 0;
-
-    for (i = 1; i <= _idtypename_cnt ; i++)
-        if(strcmp(type,_idtypename[i])==0)
-            return i;
-    return 0;
-}
-
-char *abac_idtype_string(int i)
-{
-    if(i > _idtypename_cnt) {
-        printf("bad idtypename idx %d\n", i);
-        panic("abac_idtype_string: went out of range on idtypename");
-    }
-    return (char*) _idtypename[i];
-}
-
-// convert a chunk to a lowercase binary string
-// malloc's the string
-static char *_chunk_to_string(chunk_t chunk) {
-    int i;
-
-    char *ret = abac_xmalloc(chunk.len * 2 + 1);
-
-    for (i = 0; i < chunk.len; ++i)
-        sprintf(ret + 2 * i, "%02x", chunk.ptr[i]);
-
-    return ret;
-}
-
-// verify that cert was issued by issuer
-// cert and issuer can be the same, in which case the self-sig is validated
-int verify_signature(certificate_t *issuer_cert, certificate_t *cert) {
-/** XXX for 5.0.1 
-    if (cert->issued_by(cert, issuer_cert, NULL))
-*/
-    if (cert->issued_by(cert, issuer_cert))
-        if (cert->get_validity(cert, NULL, NULL, NULL))
-            return 1;
-    return 0;
-}
-
-// verify that cert is still valid
-static int _verify_validity(certificate_t *cert) {
-    if (cert->get_validity(cert, NULL, NULL, NULL))
-        return 1;
-    return 0;
-}
-
-/**
- * Init the verifier subsystem.
- */
-void abac_verifier_init(void) {
-    // silence all debugging
-
-    if(debug)fprintf(stderr, "abac_verifier_init... init strongswan..\n");
-    if (!library_init(NULL))
-        exit(SS_RC_LIBSTRONGSWAN_INTEGRITY);
-
-    if (!lib->plugins->load(lib->plugins, NULL,
-            lib->settings->get_str(lib->settings, "pki.load", PLUGINS)))
-        exit(SS_RC_INITIALIZATION_FAILED);
-
-    attr_hashkeyid_list = abac_list_new();
-    id_hashkeyid_list = abac_list_new();
-}
-
-/**
- * Uninitialize the system, free up any allocated memory.
- */
-void abac_verifier_deinit(void) {
-    if(debug)fprintf(stderr, "abac_verifier_deinit... being called..\n");
-
-    abac_id_credential_t *ptr;
-    while ((ptr = id_creds) != NULL) {
-        if(debug) fprintf(stderr, "abac_verifier_deinit: deleting id (%s)\n",abac_id_name(ptr->id));
-        HASH_DEL(id_creds, ptr);
-
-        free(ptr->hashkeyid); 
-        free(ptr->pl_clause);
-        abac_id_free(ptr->id); 
-        free(ptr);
-    }
-
-    abac_credential_t *ptr2;
-    while ((ptr2 = attr_creds) != NULL) {
-        HASH_DEL(attr_creds, ptr2);
-        if(debug) {
-           fprintf(stderr, "abac_verifier_deinit: deleting attr hashkey(%s)\n",ptr2->hashkeyid); 
-        }
-        free(ptr2->hashkeyid);
-        abac_attribute_free(ptr2->attr);
-        char *cur=NULL;
-        abac_list_foreach(ptr2->pl_clauses, cur,
-              free(cur);
-        );
-        free(ptr2->pl_clauses);
-        free(ptr2);
-    }
-
-    if(attr_hashkeyid_list) { 
-        if(debug) fprintf(stderr, "looking to free attr_hashkeyid_list..\n");
-        char *cur;
-        abac_list_foreach(attr_hashkeyid_list, cur,
-            if(cur) free(cur);
-        );
-        abac_list_free(attr_hashkeyid_list);
-    }
-
-    if(id_hashkeyid_list) { 
-        if(debug) fprintf(stderr, "looking to free id_hashkeyid_list..\n");
-        char *cur;
-        abac_list_foreach(id_hashkeyid_list, cur,
-            if(cur) {
-               if(debug) fprintf(stderr, "hum.. id hashkey being freed.. %s\n", cur); 
-               free(cur);
-            }
-        );
-        abac_list_free(id_hashkeyid_list);
-    }
-
-    if(debug) fprintf(stderr, "now it is time to deinit strongswan lib..\n");
-    library_deinit();
-}
-
-abac_id_credential_t *abac_verifier_add_id_credential(abac_id_t *a_id)
-{ 
+            fprintf(fp," [%s,%s] #n\n", abac_id_idtype_string(ptr), abac_id_name(ptr));
+}
+
+void abac_print_typed_cred_info(abac_credential_t *cred, FILE *fp)
+{
+    if(fp == NULL)
+        fp=stdout;
+
+    abac_attribute_t *ptr=cred->attr;
+    abac_aspect_t *head=abac_attribute_head(ptr);
+    abac_aspect_t *tail=abac_attribute_tail(ptr);
+
+    fprintf(fp," ");
+    abac_print_aspect_typed_string_with_condition(head,fp);
+    fprintf(fp," <- ");
+    abac_print_aspect_typed_string_with_condition(tail,fp);
+    fprintf(fp,"\n");
+}
+
+
+/* not duplicated */
+abac_credential_t *abac_credential_lookup(char* cred_string)
+{
+    assert(cred_string);
+    DEBUG_PRINTF("abac_credential_lookup: looking for (%s)\n", cred_string);
+    abac_credential_t *attr_cred;
+    HASH_FIND_STR(abac_session->attr_creds, cred_string, attr_cred);
+    if (attr_cred == NULL) {
+        DEBUG_PRINTF("abac_credential_lookup:NOT FOUND..\n");
+        return NULL;
+    }
+    DEBUG_PRINTF("abac_credential_lookup:FOUND, looking for (%s)\n", cred_string);
+    abac_credential_t *rt=attr_cred;
+    return rt;
+}
+
+/* not duplicated */
+abac_id_credential_t *abac_id_credential_lookup(char* name)
+{
+    assert(name);
+    DEBUG_PRINTF("abac_id_credential_lookup: looking for (%s)\n", name);
     abac_id_credential_t *id_cred;
-    char *cn=abac_id_cn(a_id);
-    char *keyid=abac_id_keyid(a_id);
-
-    if(debug) {
-         fprintf(stderr, "abac_verifier_add_id_credential, cn(%s),keyid(%s)\n",
-                cn, keyid);
-    }
-
-    // add the abac_id to the map of id credentials
-    id_cred = abac_xmalloc(sizeof(abac_id_credential_t));
-    id_cred->hashkeyid = abac_xstrdup(keyid);
-    id_cred->id=abac_id_dup(a_id);
-
-    /* special handling here */
-    if(USE("ABAC_CN")) {
-        id_cred->pl_clause = generate_pl_type_clause(cn, abac_id_idtype(a_id));
-        } else {
-           id_cred->pl_clause=generate_pl_type_clause(prologIt(keyid), abac_id_idtype(a_id));
-    }
-    HASH_ADD_KEYPTR(hh, id_creds, id_cred->hashkeyid, strlen(id_cred->hashkeyid), id_cred);
-    if(debug)
-        fprintf(stderr, "-->adding into id_creds, (%s)..cnt(%d)(%d)\n",
-                                   id_cred->hashkeyid, HASH_COUNT(id_creds),(int)id_cred);
-
-    assert(id_hashkeyid_list);
-    abac_list_add(id_hashkeyid_list, abac_xstrdup(id_cred->hashkeyid));
+    HASH_FIND_STR(abac_session->id_creds, name, id_cred);
+    if (id_cred == NULL) {
+        DEBUG_PRINTF("abac_id_credential_lookup:NOT FOUND..\n");
+        return NULL;
+    }
+    DEBUG_PRINTF("  --> sha is (%s)\n", abac_id_keyid(id_cred->id));
+    DEBUG_PRINTF("  --> cn is (%s)\n", abac_id_cn(id_cred->id));
     return id_cred;
 }
 
-/* have to find the last cn 
-   CN=test/emailAddress=abac.isi.edu, CN=12345678
-   CN=client
-   ..CN=255a03f3-ed30/emailAddress=..
-*/
-static char* _extract_cn(char *string)
-{
-  /* find the first CN= */
-  char *ptr=strstr(string,"CN=");
-  if(ptr == NULL) return NULL;
-
-  /* look for last CN= */
-  while(1) {
-     char *tptr=ptr+3;
-     char *p=strstr(tptr,"CN=");
-     if(p) ptr=p;
-         else break;
-  }
-
-  /* remove the possible additional stuff */
-  char *cn=abac_xstrdup(ptr); /* it would get write over */
-  char *nptr=strtok(cn,"/");
-  char *pcn=abac_xmalloc(sizeof(char) * strlen(nptr));
-  pcn[0]='p';
-  /* special case.. replace empty space with _ */
-  int i=strlen(nptr);
-  while(i--) 
-     if(nptr[i]==' ') nptr[i]='_';
-  sscanf(nptr,"CN=%s", &pcn[1]);
-  free(cn);
-  return pcn;
-}
-
-/**
- * Load an ID 
- */
-static int _load_id(abac_id_t **a_id,certificate_t *cert, abac_id_credential_t **id_cred_ret) {
-    abac_id_credential_t *id_cred = NULL;
-    char *keyid = NULL;
-    chunk_t id;
-    int ret;
-    x509_t *x509 = (x509_t *)cert;
-
-    assert(cert != NULL);
-
-    // get the key ID, add p to keyid SHA here */
-    id = x509->get_subjectKeyIdentifier(x509);
-    keyid = _chunk_to_string(id);
-
-    /* Mike said this is the way it is */
-    char *str=NULL;
-    int rv = asprintf(&str, "%Y", cert->get_issuer(cert));
-
-    /* add p to cn name here, if there is no useable one
-       reuse keyid */
-    char *cn=_extract_cn(str);
-    if(cn == NULL) {
-        if(debug)
-            fprintf(stderr, "DEBUG:did not find usable cn, reuse keyid\n");
-        cn=abac_xstrdup(keyid);
-    }
-
-    if(debug) {
-        fprintf(stderr, "DEBUG:keyid %s \n", keyid);
-        fprintf(stderr, "DEBUG:issuer '%s' \n", str);
-        fprintf(stderr, "DEBUG:cn %s \n", cn);
-    }
-    free(str);
-
-    // if we already have this cert 'error' with success
-    HASH_FIND_STR(id_creds, keyid, id_cred);
-    if (id_cred != NULL) {
-        if(debug) fprintf(stderr, "existing cert \n");
-        ret = ABAC_CERT_EXISTS;
-        goto error;
-    }
-
-    // validate validity
-    ret = _verify_validity(cert);
-    if (!ret) {
-        ret = ABAC_CERT_INVALID;
-        goto error;
-    }
-
-    // validate sig
-    ret = verify_signature(cert, cert);
-    if (!ret) {
-        /* well.. this is not a self signed cert, don't fault it anymore */
-        if(debug) fprintf(stderr, "This is not a self-signed cert \n");
-        } else {
-            if(debug) fprintf(stderr, "This is a self-signed cert \n");
-    }
-
-    // success, add a new abac_id
-    if(*a_id==NULL) {
-        *a_id=abac_id_keyid_new(keyid,cn,cert);
-    }
-
-    abac_id_credential_t *n_id_cred=abac_verifier_add_id_credential(*a_id);
-    *id_cred_ret=n_id_cred;
-
-    if (keyid != NULL) free(keyid);
-    if (cn != NULL) free(cn);
-
-    return ABAC_CERT_SUCCESS;
-
-error:
-    if (keyid != NULL) free(keyid);
-    if (cn != NULL) free(cn);
-
-    return ret;
-}
-
-/* collect all the creds stored so far */
-abac_stack_t *abac_verifier_dump_creds()
+/* collect all the creds stored so far for the session */
+abac_stack_t *abac_dump_creds()
 {
     abac_stack_t *cred_list = abac_stack_new();
 
     int cnt=0;
-    if(attr_hashkeyid_list) {
+    if(abac_session->attr_hashkeyid_list) {
         char *keyid;
         abac_credential_t *cred;
-        abac_list_foreach(attr_hashkeyid_list, keyid,
+        abac_list_foreach(abac_session->attr_hashkeyid_list, keyid,
             cred=abac_credential_lookup(keyid);
             abac_stack_push(cred_list, cred);
@@ -410,18 +397,19 @@
         );
     }
-    if(debug) fprintf(stderr, "abac_verifier_dump_cred: %d\n",cnt);
+    DEBUG_PRINTF("abac_dump_cred: %d\n",cnt);
     return cred_list;
 }
 
-/* collect all the id stored so far */
-abac_stack_t *abac_verifier_dump_principals()
+
+/* collect all the id creds stored so far for the session */
+abac_stack_t *abac_dump_principals()
 {
     abac_stack_t *id_list = abac_stack_new();
 
     int cnt=0;
-    if(id_hashkeyid_list) {
+    if(abac_session->id_hashkeyid_list) {
         char *keyid;
         abac_id_credential_t *id;
-        abac_list_foreach(id_hashkeyid_list, keyid,
+        abac_list_foreach(abac_session->id_hashkeyid_list, keyid,
             id=abac_id_credential_lookup(keyid);
             abac_stack_push(id_list, id);
